SystemOrganization addCategory: #'PhysicalEtoys-Utilities'!

NCAAConnectorMorph subclass: #PhysicalEtoysWireMorph
	instanceVariableNames: 'isControllingConnections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhysicalEtoys-Utilities'!

!PhysicalEtoysWireMorph commentStamp: 'Richo 9/15/2009 12:22' prior: 0!
Abstract class. I represent the wire which connects different etoys. The difference with my superclass is that I control that the connections are valid by checking the classes of my sourceMorph and destinationMorph. Subclasses have to override #validConnectionClasses (see class side).!

!PhysicalEtoysWireMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 8/25/2009 10:19'!
defaultNameStemForInstances
^'Wire'! !

!PhysicalEtoysWireMorph class methodsFor: 'instance creation' stamp: 'Richo 9/1/2009 16:00'!
fromMorph: aMorph toMorph: anotherMorph
"Recuerda los morphs originales para borrarse si estos cambian"
	^( (super
		fromMorph: aMorph
		toMorph: anotherMorph
		) ) beSmoothCurve; beOrthogonal: true; startControllingConnections! !

!PhysicalEtoysWireMorph class methodsFor: 'constants' stamp: 'Richo 9/1/2009 15:54'!
validConnectionClasses
"Devuelve una coleccin de clases vlidas para conectarse"
self subclassResponsibility! !

!PhysicalEtoysWireMorph methodsFor: 'menu' stamp: 'Richo 10/7/2008 18:20'!
addCustomMenuItems: aMenu hand: aHand 
"Esto evita que se aadan las opciones de connectors al men"
	^ aMenu! !

!PhysicalEtoysWireMorph methodsFor: 'connection control' stamp: 'Richo 9/8/2009 13:46'!
controlConnections
"No borrar, es muy importante!! Se fija si las conexiones son vlidas y si no es as se elimina"

(self hasValidClass: self sourceMorph) ifFalse: [self isInWorld ifTrue: [self delete]].
(self hasValidClass: self destinationMorph) ifFalse: [self isInWorld ifTrue: [self delete]].

Cursor normal show.! !

!PhysicalEtoysWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 15:25'!
handlesMouseOver: evt 
	^ false! !

!PhysicalEtoysWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 15:25'!
handlesMouseOverDragging: evt 
	^ false! !

!PhysicalEtoysWireMorph methodsFor: 'as yet unclassified' stamp: 'Richo 9/8/2009 13:47'!
hasValidClass: aMorph 
	self class validConnectionClasses
		do: [:each | (aMorph isKindOf: each)
				ifTrue: [^ true]].
	^ false! !

!PhysicalEtoysWireMorph methodsFor: 'initialization' stamp: 'Richo 9/1/2009 16:14'!
initialize
"isControllingConnections se debe inicializar primero porque sino luego tira error porque en algn lado se ejecuta #connectionsChanged. Una alternativa sera usar lazy initialization, lo que sea ms claro"
isControllingConnections := false.
super initialize.! !

!PhysicalEtoysWireMorph methodsFor: 'testing' stamp: 'Richo 2/11/2009 13:44'!
isPlugged
	^ self sourceMorph notNil
		and: [self destinationMorph notNil]! !

!PhysicalEtoysWireMorph methodsFor: 'connection control' stamp: 'Richo 9/1/2009 11:53'!
startControllingConnections
isControllingConnections := true.! !

!PhysicalEtoysWireMorph methodsFor: 'connection control' stamp: 'Richo 9/1/2009 11:53'!
stopControllingConnections
isControllingConnections := false.! !

!PhysicalEtoysWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 15:07'!
understandsBorderVocabulary
^false! !

!PhysicalEtoysWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 18:21'!
wantsConnectionVocabulary
	^ false! !

!PhysicalEtoysWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 15:04'!
wantsConnectorVocabulary
	^ false! !

!PhysicalEtoysWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 18:21'!
wantsEmbeddingsVocabulary
	^ false! !

!PhysicalEtoysWireMorph methodsFor: 'as yet unclassified' stamp: 'Richo 9/8/2009 13:46'!
wantsToAttachEnd: index toMorph: aMorph
^self hasValidClass: aMorph ! !
